#include<bits/stdc++.h>
#define MAXN (int)2e7+20
#define MAXM (int)1e5+10
#define MOD 998244353
using namespace std;
int n, m;
int a[MAXN];
int b[MAXM];
long long c, x=0ll, c0;
int main()
{
    cin >> n >> m;
    for(int i=1;i<=m;i++)cin >> b[i];
    cin >> c;
    c0=c;
    for(int i=1;i<=n;i++)a[i]=i;
    for(int i=0;i<=n-m;i++)for(int j=1;j<=m;j++)a[i+b[j]]=a[i+j];
    for(int i=1;i<=n;i++)
    {
        x = (x%MOD+(c%MOD*a[i]%MOD)%MOD)%MOD;
        c = (c%MOD*c0%MOD)%MOD;
    }
    cout << x;
    return 0;
}